local function titleCase( s )
    local result = string.gsub( s, "(%a)([%w_']*)",
        function( first, rest )
            return first:upper() .. rest:lower()
        end
    )
    return result
end

MunMap.allLanguages = {
	["en"] = {
		["filter1"] = "The Lady",
		["filtertooltip1"] = titleCase(GetAbilityDescription(60574)),
		["filter2"] = "The Lover",
		["filtertooltip2"] = titleCase(GetAbilityDescription(60584)),
		["filter3"] = "The Lord",
		["filtertooltip3"] = titleCase(GetAbilityDescription(60579)),
		["filter4"] = "The Mage",
		["filtertooltip4"] = titleCase(GetAbilityDescription(60550)),
		["filter5"] = "The Tower",
		["filtertooltip5"] = titleCase(GetAbilityDescription(60554)),
		["filter6"] = "The Atronach",
		["filtertooltip6"] = titleCase(GetAbilityDescription(60569)),
		["filter7"] = "The Serpent",
		["filtertooltip7"] = titleCase(GetAbilityDescription(60594)),
		["filter8"] = "The Shadow",
		["filtertooltip8"] = titleCase(GetAbilityDescription(60599)),
		["filter9"] = "The Ritual",
		["filtertooltip9"] = titleCase(GetAbilityDescription(60589)),
		["filter10"] = "The Thief",
		["filtertooltip10"] = titleCase(GetAbilityDescription(60610)),
		["filter11"] = "The Warrior",
		["filtertooltip11"] = titleCase(GetAbilityDescription(60462)),
		["filter12"] = "The Apprentice",
		["filtertooltip12"] = titleCase(GetAbilityDescription(60556)),
		["filter13"] = "The Steed",
		["filtertooltip13"] = titleCase(GetAbilityDescription(60604))
	}
}

MunMap.language = (GetCVar("language.2") or "en")
MunMap.localization = MunMap.allLanguages[MunMap.language]